/* Reflow Oven Controller
*
* Copyright (C) 2020  Mario Hüttel <mario.huettel@gmx.net>
*
* This file is part of the Reflow Oven Controller Project.
*
* The reflow oven controller is free software: you can redistribute it and/or modify
* it under the terms of the GNU General Public License version 2 as
* published by the Free Software Foundation.
*
* The Reflow Oven Control Firmware is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with the reflow oven controller project.
* If not, see <http://www.gnu.org/licenses/>.
*/

#include <reflow-controller/onewire-if.h>

int onewire_if_init_uart(struct stm_uart *uart, uint32_t brr_val, USART_TypeDef *onewire_uart, volatile uint32_t *rcc_reg, uint8_t rcc_bit_num)
{
	if (!uart)
		return -1000;

	uart->rx = 1;
	uart->tx = 1;
	uart->brr_val = brr_val;
	uart->rcc_reg = rcc_reg;
	uart->uart_dev = onewire_uart;
	uart->rcc_bit_no = rcc_bit_num;
	uart->dma_rx_buff = NULL;
	uart->dma_tx_buff = NULL;

	return uart_init(uart);
}

void onewire_if_disable(struct stm_uart *uart)
{
	if (!uart)
		return;

	uart_disable(uart);
}

int onewire_if_send_byte(struct stm_uart *uart)
{

}

int onewire_if_receive_byte(struct stm_uart *uart)
{

}
